//********************************************************************
unsigned long micros_sp = 0, micros_th = 0;
volatile int  tz; 
volatile int  sz;
volatile int  sp;                            //импульсы спидометра
volatile int  th;                            //импульсы тахометра
int           analogInput [15];              //массив аналоговых значений
int           digitalInput[29];              //массив цифровых значений
String        resultString = "";             //строка
int           i;                             //счетчик циклов
//********************************************************************
void setup(){ 
  for(i=0; i<=14; i++){                     //обнуление массива аналоговых значений  
    digitalInput[i]=0; 
  }
  for(i=0; i<=28; i++){                     //обнуление массива цифровых значений  
    analogInput[i]=0; 
  }
  Serial.begin(115200); 
  Serial2.begin(115200);                     //инициализация ком порта 
  attachInterrupt(0, speedometr, RISING);   //прерывание спидометра по фронтам импульса
  attachInterrupt(1, tahometr,   RISING);   //прерывание тахометра по фронтам импульса
} 
//********************************************************************
void loop(){
  analogInput[0]   =      analogRead(4);         //  напряжение
  analogInput[1]   =      analogRead(2);         //  топливо
  analogInput[2]   =      analogRead(6);         //  температура охлаждения
  analogInput[3]   =      0;//analogRead(9);         //  температура в салоне
  analogInput[4]   =      0;//analogRead(8);         //  температура за бортом
  analogInput[5]   =      0;//analogRead(1);         //  дифферент
  analogInput[6]   =      0;//analogRead(2);         //  крен
  analogInput[7]   =      analogRead(9);         //  аналог
  analogInput[8]   =      analogRead(10);        //  аналог
  analogInput[9]   =      0;//analogRead(11);        //  резерв
  analogInput[10]  =      0;//analogRead(12);        //  резерв
  analogInput[11]  =      0;//analogRead(13);        //  резерв
  analogInput[12]  =      0;//analogRead(14);        //  резерв
  analogInput[13]  =      0;//analogRead(15);        //  резерв
  analogInput[14]  =      0;//analogRead(0);         //  пин неисправен
  
  
  digitalInput[0] =       digitalRead(47);       //  зажигание
  digitalInput[1] =       digitalRead(8);        //  ночной скин
  //********************************************************************
  digitalInput[2]  =      digitalRead(53) +      //  кнопка выбора
                          digitalRead(52) * 2;   //  кнопка действия 
  //********************************************************************
  digitalInput[3]  =      digitalRead(32) +      //  левый поворот
                          digitalRead(33) * 2;   //  правый поворот
  //********************************************************************
  digitalInput[4]  =      digitalRead(28) +      //  габарит
                          digitalRead(29) * 2;   //  дальний
 //********************************************************************
  digitalInput[5]  =      digitalRead(30) +      //  птф передние
                          digitalRead(31) * 2;   //  птф задний
 //********************************************************************
  digitalInput[6]  =      !digitalRead(24);       //  чек
  digitalInput[7]  =      0;//digitalRead(49);       //  уровень тж
  digitalInput[8]  =      !digitalRead(27);       //  ручник
  digitalInput[9]  =      0;//digitalRead(50);       //  износ колодок
  digitalInput[10] =      0;// !digitalRead(48);       //  лампа топлива
  digitalInput[11] =      0;//digitalRead(51);       //  уровень ож
  digitalInput[12] =      !digitalRead(22);       //  давление масла
  digitalInput[13] =      0;//digitalRead(37);       //  лампа вентилятора
  digitalInput[14] =      !digitalRead(23);       //  зарядка
  digitalInput[15] =      !digitalRead(25);       //  ABS
  digitalInput[16] =      0;//digitalRead(26);       //  SRS
  digitalInput[17] =      0;//digitalRead(18);       //  ремень
  digitalInput[18] =      !digitalRead(46);       //  двери
  digitalInput[19] =      0;//digitalRead(42);       //   p
  digitalInput[20] =      0;//digitalRead(39);       //   r
  digitalInput[21] =      0;//digitalRead(24);       //   n
  digitalInput[22] =      0;//digitalRead(46);       //   d
  digitalInput[23] =      0;//digitalRead(52);       //   s
  digitalInput[24] =      0;//digitalRead(21);       //   резерв
  digitalInput[25] =      0;//digitalRead(26);       //   резерв
  digitalInput[26] =      0;//digitalRead(27);       //   резерв
  digitalInput[27] =      0;//digitalRead(28);       //   резерв
  digitalInput[28] =      0;//digitalRead(44);       //   резерв
  
  
    
  resultString = String(resultString + sp);
  resultString = String(resultString + ",");
  resultString = String(resultString + th);
  resultString = String(resultString + ",");
  for(i=0; i<=14; i++){                    //передаем аналоговые данные из массива в COM-port
    resultString = String(resultString + analogInput[i]);
    resultString = String(resultString + ",");
  } 
  for(i=0; i<=28; i++){                    //передаем цифровые данные из массива в COM-port  
    resultString = String(resultString  + digitalInput[i]);
  } 
  resultString = String(resultString + ":\n");
  Serial2.print (resultString);
  Serial.print (resultString);
  resultString =  String("");
  tz = tz - 1;
  sz = sz - 1;
  if (tz == 0){th = 0;}
  if (sz == 0){sp = 0;}
  delay(50);
}
//********************************************************************
void speedometr(){                          //измеряем частоту на входе спидометра по прерыванию
   sp=(730000.0/( micros() - micros_sp));
   micros_sp = micros();
   sz = 10;
}
//********************************************************************
void tahometr(){                            //измеряем частоту на входе тахометра по прерыванию
  th=(29000000.0/( micros() - micros_th));
  micros_th = micros();
  tz = 10;
}

